--  Levels are 12x12
--  Tile 0 is None
--  Tile 1 is Wall
--  Tile 2 is Key
--  Tile 3 is Door
--  Tile 4 is Zap
--  Tile 5 is Zap2
--  Tile 6 is Tele
--  Tile 7 is Port
--  Tile 8 is Sign
--  Tile 9 is Next

--  Scale for Normal: 1.0
--  Scale for Larger: 0.6

function doNextLevel(text)
	GAMESTATE = 0
	LEVELDESC = text
	CURRENTLEVEL = CURRENTLEVEL + 1
end
function doChangeLevel()
	walltiles = {}
	keytiles = {}
	doortiles = {}
	zaptiles = {}
	nexttiles = {}
	teletiles = {}
	porttiles = {}
	signtiles = {}
	gentiles = {}
	KEYS = 0
	loadUpLevel(allLevels[CURRENTLEVEL])
end
function loadUpLevel(level)
	LTHEME = level.theme
	LETSBEGINPLAY = false
	LEVELDS = 768/level.scale/64
	local newmousey = math.floor((level.spawn-1)/level.scale)
	local newmousex = (level.spawn-1) - newmousey*level.scale
	DOMX, DOMY = math.floor(newmousex*64*LEVELDS+32*LEVELDS), math.floor(newmousey*64*LEVELDS+32*LEVELDS)
	love.mouse.setPosition(DOMX, DOMY)
	for k,v in pairs(level) do
		if type(k) ~= "number" then break end
		local puty = math.floor((k-1)/level.scale)
		local putx = (k-1) - puty*level.scale
		if v == 1 then
			table.insert(walltiles, walltile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 2 then
			table.insert(keytiles, keytile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 3 then
			table.insert(doortiles, doortile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 4 then
			table.insert(zaptiles, zaptile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 5 then
			table.insert(zaptiles, zaptile:New(putx*64*LEVELDS, puty*64*LEVELDS, 100))
		end
		if v == 6 then
			table.insert(teletiles, teletile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 7 then
			table.insert(porttiles, porttile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 8 then
			table.insert(signtiles, signtile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 9 then
			table.insert(nexttiles, nexttile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
		if v == 10 then
			table.insert(gentiles, gentile:New(putx*64*LEVELDS, puty*64*LEVELDS))
		end
	end
	LEVELDESC = level.win or "undefined"
	LEVELSIGN = level.sign or ""
end

allLevels = {

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 9, 1,
1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="Good start!", sign=nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 0, 0, 0, 7, 1, 0, 6, 1,
1, 0, 0, 1, 0, 2, 2, 0, 1, 0, 0, 1,
1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 0, 0, 0, 9, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="Slick moves, brutha!", sign=nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 4, 0, 5, 0, 5, 5, 1,
1, 0, 0, 0, 0, 0, 4, 0, 5, 0, 4, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 5, 4, 1,
1, 0, 0, 9, 0, 0, 0, 0, 1, 4, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 4, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 5, 1,
1, 4, 0, 4, 0, 4, 5, 4, 5, 5, 0, 1,
1, 5, 4, 0, 0, 5, 5, 0, 5, 0, 4, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="Great Job! Keep going...", sign=nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="Cool!", sign=nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 6, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 2, 0, 0,
1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 1, 3, 1, 1, 1, 3, 1, 1, 0, 1,
1, 0, 1, 0, 7, 1, 0, 0, 0, 1, 0, 1,
1, 0, 1, 0, 0, 1, 0, 9, 0, 1, 0, 1,
1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="You're doing pretty good! Here's a little code to show the FPS:\nType: (space) fps before a level.", sign=nil
},

{
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 1, 3, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 1, 2, 1, 0, 0, 0, 9, 1,
1, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0, 1,
1, 0, 6, 0, 1, 2, 1, 0, 0, 0, 0, 1,
1, 0, 0, 0, 1, 7, 1, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1,
spawn=14, scale=12, win="I absolutely LOVE your work!", sign="Maybe these levels are just a bit too small..."
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1,
1, 0, 0, 0, 0, 1, 0, 0, 4, 0, 5, 0, 1, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 8, 0, 1, 0, 4, 0, 5, 5, 0, 1, 0, 0, 0, 9, 0, 0, 1,
1, 0, 0, 0, 0, 1, 4, 0, 5, 0, 5, 4, 1, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 1, 0, 0, 0, 5, 4, 2, 1, 0, 0, 0, 0, 0, 0, 1,
1, 4, 1, 1, 3, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1,
1, 5, 1, 0, 0, 0, 0, 0, 0, 1, 2, 0, 1, 1, 0, 1, 1, 1, 0, 1,
1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1,
1, 5, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1,
1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1,
1, 4, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1,10, 1,10, 1,
1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1,
1, 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 1,
1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 1,
1, 0, 0, 2, 0, 0, 1, 0, 0, 7, 0, 0, 1, 0, 0, 0, 1, 0, 1, 1,
1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 0, 1,
1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1,
1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=22, scale=20, win="Phew! That one was hard! Here is a password to skip to level 8!\nType: (space) xyzzy before a level.", sign="It's funny... This building is larger, but it feels more cramped."
},

{
1, 1, 1, 1, 1,
1, 0, 0, 0, 1,
1, 2, 1, 3, 1,
1, 8, 1, 9, 1,
1, 1, 1, 1, 1,
spawn=7, scale=5, win="How's your wrist?", sign="This place is so tiny!! But it's also large in a way..."
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 8, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 6, 1,
1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1,
1, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1,
1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1,
1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1,
1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 1,10,10,10,10,10,10,10,10, 1, 9, 1, 0, 0, 0, 0, 0, 1,
1, 0, 1,10,10,10,10,10,10,10,10, 1,10, 1, 0, 0, 0, 0, 0, 1,
1, 0, 1,10,10,10,10,10,10,10,10, 1,10, 1, 0, 0, 0, 0, 0, 1,
1, 0, 3,10,10,10,10,10,10,10,10,10,10, 1, 0, 0, 0, 0, 0, 1,
1, 0, 1,10,10,10,10,10,10,10,10,10,10, 1, 0, 0, 0, 0, 0, 1,
1, 0, 1,10,10,10,10,10,10,10,10,10,10, 1, 0, 0, 0, 0, 0, 1,
1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 2, 0, 0, 1, 0, 0, 2, 0, 1, 2, 0, 0, 0, 0, 1,
1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 7, 0, 0, 3, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=22, scale=20, win="Snooping as usual, I see.", sign="It's dark.", theme="dark"
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0,10, 1, 9, 0, 0, 0, 4, 0, 1,
1, 0, 0, 5, 1, 4, 0, 0, 5, 0, 0, 1,
1,10,10,10, 1, 0, 5, 0, 0, 4, 4, 1,
1,10,10,10, 1, 1, 1, 1, 5, 0, 0, 1,
1,10, 5,10, 4, 4,10,10, 0, 0, 0, 1,
1,10,10,10, 4,10,10,10,10,10,10, 1,
1, 5,10,10,10,10,10, 4,10,10,10, 1,
1,10,10,10,10, 4,10,10,10,10,10, 1,
1,10,10, 4,10,10,10,10,10,10,10, 1,
1,10,10, 4,10,10,10,10,10,10, 4, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="I love you.", sign=nil, theme="dark"
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=14, scale=12, win="Great Job! Keep going...", sign="The End!\nThanks for testing this version. You rock! Any feedback or suggestions? Did you make a level? Post it!"
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
spawn=22, scale=20, win="Nice Navigation!", sign=nil
},

}