require("controls")
require("tiles")
require("funcs")
require("levels")
function love.load()
	--RESOURCES
	love.graphics.setBackgroundColor(20, 20, 20, 255)
	wallimg = love.graphics.newImage("walltile.png")
	keyimg = love.graphics.newImage("keytile.png") 
	doorimg = love.graphics.newImage("locktile.png")
	zapimg = love.graphics.newImage("zaptile.png")
	nextimg = love.graphics.newImage("nextlevel.png")
	teleimg = love.graphics.newImage("teletile.png")
	portimg = love.graphics.newImage("porttile.png")
	signimg = love.graphics.newImage("signtile.png")
	genimg = love.graphics.newImage("gentile.png")
	keysnd = love.audio.newSource("pickupcoin.wav", static) -- Thanks for generating the sounds, bfxr.net!
	doorsnd = love.audio.newSource("hithurt.wav", static)
	diesnd = love.audio.newSource("blipselect.wav", static)
	nextsnd = love.audio.newSource("powerup.wav", static)
	telesnd = love.audio.newSource("powerup2.wav", static)
	buttonFont = love.graphics.newFont(16)
	titleFont = love.graphics.newFont(32)
	--OPTIONAL CODES
	OPTN_FPS = false
	--INITIAL GAME VARS
	CHEATSTRING = ""
	LEVELDS = 1
	KEYS = 0
	CURRENTLEVEL = 1
	GAMESTATE = 0
	LETSBEGINPLAY = false
	SPAWNING = false
	READINGSIGN = false
	DOMX = 0
	DOMY = 0
	doChangeLevel()
	LEVELDESC = "Mouse Game\nBy DumpOnIt"
	table.insert(menuButtons, buttonz:New("Start Level", 64, 64, 128, 64, function () doChangeLevel(); GAMESTATE = 1 end))
	table.insert(menuButtons, buttonz:New("New Game", 448, 64, 128, 64, function () CURRENTLEVEL = 1; doChangeLevel(); LEVELDESC = "Progress Cleared!"; telesnd:stop(); telesnd:play() end))
	table.insert(menuButtons, buttonz:New("Exit", 576, 64, 128, 64, function () love.event.push("quit") end))
end
function love.update(dt)
	READINGSIGN = false
	menuButtons[1].label = "Start Level "..CURRENTLEVEL
	if GAMESTATE == 1 then
		for k,v in pairs(walltiles) do
			v:update(dt)
		end
		for k,v in pairs(keytiles) do
			v:update(dt)
		end
		for k,v in pairs(doortiles) do
			v:update(dt)
		end
		for k,v in pairs(zaptiles) do
			v:update(dt)
		end
		for k,v in pairs(nexttiles) do
			v:update(dt)
		end
		for k,v in pairs(teletiles) do
			v:update(dt)
		end
		for k,v in pairs(porttiles) do
			v:update(dt)
		end
		for k,v in pairs(signtiles) do
			v:update(dt)
		end
		for k,v in pairs(gentiles) do
			v:update(dt)
		end
		if DOMX == love.mouse.getX() and love.mouse.getY() == DOMY then
			LETSBEGINPLAY = true
		elseif not LETSBEGINPLAY then
			love.mouse.setPosition(DOMX, DOMY)
		end
	end
end
function love.draw()
	local xmouse, ymouse = love.mouse.getX(), love.mouse.getY()
	if GAMESTATE == 0  then
		for k,v in pairs(menuButtons) do
			v:draw()
		end
		love.graphics.setFont( titleFont)
		love.graphics.printf( LEVELDESC, 0, 368, 768, "center")
		for k,v in pairs(menuButtons) do
			v:draw()
		end
	end
	if GAMESTATE == 1 then
		for k,v in pairs(walltiles) do
			v:draw()
		end
		for k,v in pairs(keytiles) do
			v:draw()
		end
		for k,v in pairs(doortiles) do
			v:draw()
		end
		for k,v in pairs(zaptiles) do
			v:draw()
		end
		for k,v in pairs(nexttiles) do
			v:draw()
		end
		for k,v in pairs(teletiles) do
			v:draw()
		end
		for k,v in pairs(porttiles) do
			v:draw()
		end
		for k,v in pairs(signtiles) do
			v:draw()
		end
		for k,v in pairs(gentiles) do
			v:draw()
		end
		if LTHEME == "dark" then
			love.graphics.setColor(0, 0, 0, 255)
			love.graphics.rectangle("fill", xmouse+128*LEVELDS, ymouse - 2000*LEVELDS, 4000*LEVELDS, 4000*LEVELDS) -- RIGHT
			love.graphics.rectangle("fill", xmouse-4000*LEVELDS-128*LEVELDS, ymouse - 2000*LEVELDS, 4000*LEVELDS, 4000*LEVELDS) -- LEFT
			love.graphics.rectangle("fill", xmouse-2000*LEVELDS-128*LEVELDS, ymouse+128*LEVELDS, 4000*LEVELDS, 4000*LEVELDS) -- BOTTOM
			love.graphics.rectangle("fill", xmouse-2000*LEVELDS-128*LEVELDS, ymouse-4000*LEVELDS-128*LEVELDS, 4000*LEVELDS, 4000*LEVELDS) -- TOP
			love.graphics.setColor(255, 255, 255, 255)
		end
		if READINGSIGN then
			local putx, puty = xmouse, ymouse + 32
			if putx > 440 then
				putx = putx - 300
			end
			love.graphics.printf( LEVELSIGN, putx, puty, 300, "center")
		end
	end
	if OPTN_FPS then love.graphics.print(love.timer.getFPS( ), 0, 0, 0, 1, 1) end
	--love.graphics.print(DOMX.." "..xmouse.."\n"..DOMY.." "..ymouse, 0, 0, 0, 1, 1)
end
function love.mousepressed(x, y, button)
	for k,v in pairs(menuButtons) do
		v:exe(x, y)
	end
end
function love.keypressed(key, unicode)
	if key == "escape" then love.event.push("quit") end
	if key == " " then CHEATSTRING = "" else CHEATSTRING = CHEATSTRING..key end
	if CHEATSTRING == "xyzzy" then
		nextsnd:stop()
		nextsnd:play()
		LEVELDESC = "Cheat Accepted!"
		CURRENTLEVEL = 8
	end
	if CHEATSTRING == "fps" then
		nextsnd:stop()
		nextsnd:play()
		LEVELDESC = "Cheat Accepted!"
		OPTN_FPS = true
	end
	if CHEATSTRING == "key" then
		nextsnd:stop()
		nextsnd:play()
		KEYS = KEYS + 1
	end
end